require 'rest_client'
require 'ostruct'

module SecureShare
  module Request

    def get path, options={}
      resource = RestClient::Resource.new "#{config.url}#{path}", options
      response = resource.get :authorization => %{Token token="#{config.api_secret}", key="#{config.api_key}"}, :content_type => :json, :accept => :json
      parse_response response
    end

    def post path, options={}
      resource = RestClient::Resource.new "#{config.url}#{path}"
      response = resource.post options, {:authorization => %{Token token="#{config.api_secret}", key="#{config.api_key}"}, :content_type => :json, :accept => :json}
      parse_response response
    end

    private

    def parse_response response
      response_object = JSON.parse(response.body)
      if response_object.is_a?(Enumerable)
        response_object.map do |object|
          OpenStruct.new(object)
        end
      else
        OpenStruct.new(response_object)
      end
    end

  end
end